/**
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator 2.4.18.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

/*
 * AccountApi.h
 *
 * 
 */

#ifndef IO_SWAGGER_CLIENT_API_AccountApi_H_
#define IO_SWAGGER_CLIENT_API_AccountApi_H_


#include "../ApiClient.h"

#include "Account.h"
#include "Error.h"
#include "Wallet.h"

#include <boost/optional.hpp>

namespace io {
namespace swagger {
namespace client {
namespace api {

using namespace io::swagger::client::model;

class  AccountApi
{
public:
    AccountApi( std::shared_ptr<ApiClient> apiClient );
    virtual ~AccountApi();
    /// <summary>
    /// 전체 계좌 조회
    /// </summary>
    /// <remarks>
    /// ## 내가 보유한 자산 리스트를 보여줍니다. 
    /// </remarks>
    pplx::task<std::vector<std::shared_ptr<Account>>> account_info(
    );
    /// <summary>
    /// 입출금 현황
    /// </summary>
    /// <remarks>
    /// ## 입출금 현황 및 블록 상태를 조회합니다.  **NOTE**: 입출금 현황 데이터는 실제 서비스 상태와 다를 수 있습니다.  입출금 현황 API에서 제공하는 입출금 상태, 블록 상태 정보는 수 분 정도 지연되어 반영될 수 있습니다. 본 API는 참고용으로만 사용하시길 바라며 실제 입출금을 수행하기 전에는 반드시 업비트 공지사항 및 입출금 현황 페이지를 참고해주시기 바랍니다. 
    /// </remarks>
    pplx::task<std::vector<std::shared_ptr<Wallet>>> account_wallet(
    );

protected:
    std::shared_ptr<ApiClient> m_ApiClient;
};

}
}
}
}

#endif /* IO_SWAGGER_CLIENT_API_AccountApi_H_ */

