# Go API client for swagger

## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 

## Overview
This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project.  By using the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API client.

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.GoClientCodegen
For more information, please visit [https://github.com/uJhin](https://github.com/uJhin)

## Installation
Put the package under your project folder and add the following in import:
```golang
import "./swagger"
```

## Documentation for API Endpoints

All URIs are relative to *https://api.upbit.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*APIKeyApi* | [**APIKeyInfo**](docs/APIKeyApi.md#apikeyinfo) | **Get** /api_keys | API 키 리스트 조회
*AccountApi* | [**AccountInfo**](docs/AccountApi.md#accountinfo) | **Get** /accounts | 전체 계좌 조회
*AccountApi* | [**AccountWallet**](docs/AccountApi.md#accountwallet) | **Get** /status/wallet | 입출금 현황
*CandleApi* | [**CandleDays**](docs/CandleApi.md#candledays) | **Get** /candles/days | 시세 캔들 조회 (일 단위)
*CandleApi* | [**CandleMinutes**](docs/CandleApi.md#candleminutes) | **Get** /candles/minutes/{unit} | 시세 캔들 조회 (분 단위)
*CandleApi* | [**CandleMonth**](docs/CandleApi.md#candlemonth) | **Get** /candles/months | 시세 캔들 조회 (월 단위)
*CandleApi* | [**CandleWeeks**](docs/CandleApi.md#candleweeks) | **Get** /candles/weeks | 시세 캔들 조회 (주 단위)
*DepositApi* | [**DepositCoinAddress**](docs/DepositApi.md#depositcoinaddress) | **Get** /deposits/coin_address | 개별 입금 주소 조회
*DepositApi* | [**DepositCoinAddresses**](docs/DepositApi.md#depositcoinaddresses) | **Get** /deposits/coin_addresses | 전체 입금 주소 조회
*DepositApi* | [**DepositGenerateCoinAddress**](docs/DepositApi.md#depositgeneratecoinaddress) | **Post** /deposits/generate_coin_address | 입금 주소 생성 요청
*DepositApi* | [**DepositInfo**](docs/DepositApi.md#depositinfo) | **Get** /deposit | 개별 입금 조회
*DepositApi* | [**DepositInfoAll**](docs/DepositApi.md#depositinfoall) | **Get** /deposits | 입금 리스트 조회
*MarketApi* | [**MarketInfoAll**](docs/MarketApi.md#marketinfoall) | **Get** /market/all | 마켓 코드 조회
*OrderApi* | [**OrderCancel**](docs/OrderApi.md#ordercancel) | **Delete** /order | 주문 취소 접수
*OrderApi* | [**OrderChance**](docs/OrderApi.md#orderchance) | **Get** /orders/chance | 주문 가능 정보
*OrderApi* | [**OrderInfo**](docs/OrderApi.md#orderinfo) | **Get** /order | 개별 주문 조회
*OrderApi* | [**OrderInfoAll**](docs/OrderApi.md#orderinfoall) | **Get** /orders | 주문 리스트 조회
*OrderApi* | [**OrderNew**](docs/OrderApi.md#ordernew) | **Post** /orders | 주문하기
*OrderApi* | [**OrderOrderbook**](docs/OrderApi.md#orderorderbook) | **Get** /orderbook | 시세 호가 정보(Orderbook) 조회
*TradeApi* | [**TradeTicker**](docs/TradeApi.md#tradeticker) | **Get** /ticker | 시세 Ticker 조회
*TradeApi* | [**TradeTicks**](docs/TradeApi.md#tradeticks) | **Get** /trades/ticks | 시세 체결 조회
*WithdrawApi* | [**WithdrawChance**](docs/WithdrawApi.md#withdrawchance) | **Get** /withdraws/chance | 출금 가능 정보
*WithdrawApi* | [**WithdrawCoin**](docs/WithdrawApi.md#withdrawcoin) | **Post** /withdraws/coin | 코인 출금하기
*WithdrawApi* | [**WithdrawInfo**](docs/WithdrawApi.md#withdrawinfo) | **Get** /withdraw | 개별 출금 조회
*WithdrawApi* | [**WithdrawInfoAll**](docs/WithdrawApi.md#withdrawinfoall) | **Get** /withdraws | 출금 리스트 조회
*WithdrawApi* | [**WithdrawKrw**](docs/WithdrawApi.md#withdrawkrw) | **Post** /withdraws/krw | 원화 출금하기


## Documentation For Models

 - [Account](docs/Account.md)
 - [ApiKey](docs/ApiKey.md)
 - [Ask](docs/Ask.md)
 - [AskAccount](docs/AskAccount.md)
 - [Bid](docs/Bid.md)
 - [BidAccount](docs/BidAccount.md)
 - [CandleDate](docs/CandleDate.md)
 - [CandleDays](docs/CandleDays.md)
 - [CandleMinutes](docs/CandleMinutes.md)
 - [Currency](docs/Currency.md)
 - [Deposit](docs/Deposit.md)
 - [DepositCompleteResponse](docs/DepositCompleteResponse.md)
 - [DepositTransferResponse](docs/DepositTransferResponse.md)
 - [ErrorInfo](docs/ErrorInfo.md)
 - [Market](docs/Market.md)
 - [MarketInfo](docs/MarketInfo.md)
 - [MemberLevel](docs/MemberLevel.md)
 - [ModelError](docs/ModelError.md)
 - [NewOrder](docs/NewOrder.md)
 - [Order](docs/Order.md)
 - [OrderChance](docs/OrderChance.md)
 - [OrderInfo](docs/OrderInfo.md)
 - [Orderbook](docs/Orderbook.md)
 - [OrderbookUnit](docs/OrderbookUnit.md)
 - [Ticker](docs/Ticker.md)
 - [Trade](docs/Trade.md)
 - [TradeTicks](docs/TradeTicks.md)
 - [Wallet](docs/Wallet.md)
 - [Withdraw](docs/Withdraw.md)
 - [WithdrawChance](docs/WithdrawChance.md)
 - [WithdrawCoin](docs/WithdrawCoin.md)
 - [WithdrawLimit](docs/WithdrawLimit.md)


## Documentation For Authorization

## Bearer
- **Type**: API key 

Example
```golang
auth := context.WithValue(context.Background(), sw.ContextAPIKey, sw.APIKey{
	Key: "APIKEY",
	Prefix: "Bearer", // Omit if not necessary.
})
r, err := client.Service.Operation(auth, args)
```

## Author

ujhin942@gmail.com

